/* $Id$

This file is part of libmspcore
Copyright © 2006  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_CORE_SEMAPHORE_H_
#define MSP_CORE_SEMAPHORE_H_

#include "mutex.h"
#include "../time/timedelta.h"

namespace Msp {

class Semaphore
{
private:
	struct Private;

	Private *priv;

public:
	Semaphore(unsigned);
	~Semaphore();

	void signal();
	void wait();
	bool wait(const Time::TimeDelta &);
};

}

#endif
